#loadgame.py
#Copyright (C) 2004 Free Software Foundation
#see GPL.txt for license.

#This file controls the load game screen. The actual load/save game
#functions are in g.loadgame/savegame

from Tkinter import *
import g
from os import listdir, path, mkdir, remove

#was a game loaded? Used to determine whether to use newgame script.
did_load = 0

#called when "Load" is pressed
def load_selected():
	if (listbox_saves.size() == 0): return
	#find the name of the save to load
	try: item_num = map(int, listbox_saves.curselection())
	except ValueError: pass
	save_title = listbox_saves.get(item_num[0])
	g.loadgame(save_title)
	global did_load
	did_load = 1
	window_loadgame.destroy()


#All keypresses in window_shop pass through here. Based on the key name,
#give the right action. ("etc", "left", "right", "up", "down", "return")
def key_handler(switch):
	if (switch == "esc"): cancel_load()
	elif (switch == "left"): pass
	elif (switch == "right"): pass
	elif (switch == "up"):
		if (listbox_saves.size() == 0): return
		try: item_num = map(int, listbox_saves.curselection())
		except ValueError: pass
		if (item_num[0] != 0):
			listbox_saves.select_clear(0, END)
			listbox_saves.selection_set(item_num[0] - 1)
		else:
			listbox_saves.select_clear(0, END)
			listbox_saves.selection_set(END)
	elif (switch == "down"):
		if (listbox_saves.size() == 0): return
		try: item_num = map(int, listbox_saves.curselection())
		except ValueError: pass
		if (item_num[0] != listbox_saves.size() - 1):
			listbox_saves.select_clear(0, END)
			listbox_saves.selection_set(item_num[0] + 1)
		else:
			listbox_saves.select_clear(0, END)
			listbox_saves.selection_set(0)
	elif (switch == "return"): load_selected()


#called when "Cancel" is pressed
def cancel_load():
	global did_load
	did_load = 0
	window_loadgame.destroy()

def key_handler_esc(event=0): key_handler("esc")
def key_handler_left(event=0): key_handler("left")
def key_handler_right(event=0): key_handler("right")
def key_handler_down(event=0): key_handler("down")
def key_handler_up(event=0): key_handler("up")
def key_handler_return(event=0): key_handler("return")

def init_window_loadgame():
	#create the window
	global window_loadgame
	window_loadgame = Toplevel()
	window_loadgame.wm_geometry("+%d+%d" % (10, 10))
	window_loadgame.focus()
	window_loadgame.resizable(0, 0)
	window_loadgame.title("Load Game")

	global did_load
	did_load = 0

	#add the saves listbox
	global scroll_saves
	scroll_saves = Scrollbar(window_loadgame)
	scroll_saves.grid(row=1, column=6, rowspan=10, sticky=NS)
	global listbox_saves
	listbox_saves = Listbox(window_loadgame, height=10,
		yscrollcommand=scroll_saves.set)
	listbox_saves.grid(row=1, column=4, columnspan=2, rowspan=10, sticky=EW)
	scroll_saves.config(command=listbox_saves.yview)

	#add the buttons
	button_load = Button(window_loadgame, text="Load",
		command=load_selected).grid(row=12, column=4)
	button_cancel = Button(window_loadgame, text="Cancel",
		command=cancel_load).grid(row=12, column=5)

	#If there is no save directory, make one.
	if path.isdir(g.mod_directory + "/saves") == 0:
		if path.exists(g.mod_directory + "/saves") == 1:
			remove(g.mod_directory + "/saves")
		mkdir(g.mod_directory + "/saves")
	#show the files contained in the saves directory.
	array_save = listdir(g.mod_directory + "/saves")
	for i in array_save:
		if i[:1] != ".":
			listbox_saves.insert(END, i)

	listbox_saves.select_set(0)

	window_loadgame.bind("<Escape>", key_handler_esc)
	window_loadgame.bind("<Left>", key_handler_left)
	window_loadgame.bind("<Right>", key_handler_right)
	window_loadgame.bind("<Up>", key_handler_up)
	window_loadgame.bind("<Down>", key_handler_down)
	window_loadgame.bind("<Return>", key_handler_return)

	window_loadgame.master.wait_window(window_loadgame)
	return did_load
